Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3337)
@@ -1833,14 +1894,15 @@
                                           t_surf_window_v(l)%t(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf_green' )
 !--                 surface temperature for green surfaces
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_surf_green_av(m) =                               & 
-                                          surf_usm_h%t_surf_green_av(m) +            &
-                                          t_surf_green_h(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_surf_green_av(m) =                               &
+                                             surf_usm_h%t_surf_green_av(m) +            &
+                                             t_surf_green_h(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_surf_green_av(m) =                         &
@@ -1848,14 +1910,15 @@
                                           t_surf_green_v(l)%t(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                 
                 CASE ( 'usm_t_surf_10cm' )
 !--                 near surface temperature for whole surfaces
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_surf_10cm_av(m) =                               & 
-                                          surf_usm_h%t_surf_10cm_av(m) +            &
-                                          t_surf_10cm_h(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_surf_10cm_av(m) =                               &
+                                             surf_usm_h%t_surf_10cm_av(m) +            &
+                                             t_surf_10cm_h(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_surf_10cm_av(m) =                         &
@@ -1863,15 +1926,16 @@
                                           t_surf_10cm_v(l)%t(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
 
                     
                 CASE ( 'usm_t_wall' )
 !--                 wall temperature for  iwl layer of walls and land
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_wall_av(iwl,m) =                           &
-                                          surf_usm_h%t_wall_av(iwl,m) +        &
-                                          t_wall_h(iwl,m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_wall_av(iwl,m) =                           &
+                                             surf_usm_h%t_wall_av(iwl,m) +        &
+                                             t_wall_h(iwl,m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_wall_av(iwl,m) =                     &
@@ -1879,14 +1943,15 @@
                                           t_wall_v(l)%t(iwl,m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_window' )
 !--                 window temperature for  iwl layer of walls and land
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_window_av(iwl,m) =                           &
-                                          surf_usm_h%t_window_av(iwl,m) +        &
-                                          t_window_h(iwl,m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_window_av(iwl,m) =                           &
+                                             surf_usm_h%t_window_av(iwl,m) +        &
+                                             t_window_h(iwl,m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_window_av(iwl,m) =                     &
@@ -1894,14 +1959,15 @@
                                           t_window_v(l)%t(iwl,m)
                        ENDDO
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_t_green' )
 !--                 green temperature for  iwl layer of walls and land
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_green_av(iwl,m) =                           &
-                                          surf_usm_h%t_green_av(iwl,m) +        &
-                                          t_green_h(iwl,m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_green_av(iwl,m) =                           &
+                                             surf_usm_h%t_green_av(iwl,m) +        &
+                                             t_green_h(iwl,m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_green_av(iwl,m) =                     &
@@ -1909,5 +1975,5 @@
                                           t_green_v(l)%t(iwl,m)
                        ENDDO
-                    ENDDO
+                    ENDIF
 
                 CASE DEFAULT
@@ -1922,10 +1988,11 @@
                 CASE ( 'usm_rad_net' )
 !--                 array of complete radiation balance
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%rad_net_av(m) =                              &
-                                          surf_usm_h%rad_net_av(m) /           &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%rad_net_av(m) =                              &
+                                             surf_usm_h%rad_net_av(m) /           &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%rad_net_av(m) =                        &
@@ -1933,5 +2000,5 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_rad_insw' )
@@ -2023,12 +2090,28 @@
                     ENDDO
                     
+                CASE ( 'usm_rad_pc_inlw' )
+                    pcbinlw_av(:) = pcbinlw_av(:) / REAL( average_count_3d, kind=wp )
+                    
+                CASE ( 'usm_rad_pc_insw' )
+                    pcbinsw_av(:) = pcbinsw_av(:) / REAL( average_count_3d, kind=wp )
+                    
+                CASE ( 'usm_rad_pc_inswdir' )
+                    pcbinswdir_av(:) = pcbinswdir_av(:) / REAL( average_count_3d, kind=wp )
+                    
+                CASE ( 'usm_rad_pc_inswdif' )
+                    pcbinswdif_av(:) = pcbinswdif_av(:) / REAL( average_count_3d, kind=wp )
+                    
+                CASE ( 'usm_rad_pc_inswref' )
+                    pcbinswref_av(:) = pcbinswref_av(:) / REAL( average_count_3d, kind=wp )
+                    
                 CASE ( 'usm_rad_hf' )
 !--                 array of heat flux from radiation for surfaces after i-th reflection
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%surfhf_av(m) =                               &
-                                          surf_usm_h%surfhf_av(m) /            &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%surfhf_av(m) =                               &
+                                             surf_usm_h%surfhf_av(m) /            &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%surfhf_av(m) =                         &
@@ -2036,14 +2119,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_wshf' )
 !--                 array of sensible heat flux from surfaces (land, roof, wall)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%wshf_eb_av(m) =                              &
-                                          surf_usm_h%wshf_eb_av(m) /           &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%wshf_eb_av(m) =                              &
+                                             surf_usm_h%wshf_eb_av(m) /           &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%wshf_eb_av(m) =                        &
@@ -2051,14 +2135,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_wghf' )
 !--                 array of heat flux from ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%wghf_eb_av(m) =                              &
-                                          surf_usm_h%wghf_eb_av(m) /           &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%wghf_eb_av(m) =                              &
+                                             surf_usm_h%wghf_eb_av(m) /           &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%wghf_eb_av(m) =                        &
@@ -2066,14 +2151,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_wghf_window' )
 !--                 array of heat flux from window ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%wghf_eb_window_av(m) =                              &
-                                          surf_usm_h%wghf_eb_window_av(m) /           &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%wghf_eb_window_av(m) =                              &
+                                             surf_usm_h%wghf_eb_window_av(m) /           &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%wghf_eb_window_av(m) =                        &
@@ -2081,14 +2167,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_wghf_green' )
 !--                 array of heat flux from green ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%wghf_eb_green_av(m) =                              &
-                                          surf_usm_h%wghf_eb_green_av(m) /           &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%wghf_eb_green_av(m) =                              &
+                                             surf_usm_h%wghf_eb_green_av(m) /           &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%wghf_eb_green_av(m) =                        &
@@ -2096,14 +2183,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_iwghf' )
 !--                 array of heat flux from indoor ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%iwghf_eb_av(m) =                              &
-                                          surf_usm_h%iwghf_eb_av(m) /           &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%iwghf_eb_av(m) =                              &
+                                             surf_usm_h%iwghf_eb_av(m) /           &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%iwghf_eb_av(m) =                        &
@@ -2111,14 +2199,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_iwghf_window' )
 !--                 array of heat flux from indoor window ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%iwghf_eb_window_av(m) =                              &
-                                          surf_usm_h%iwghf_eb_window_av(m) /           &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%iwghf_eb_window_av(m) =                              &
+                                             surf_usm_h%iwghf_eb_window_av(m) /           &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%iwghf_eb_window_av(m) =                        &
@@ -2126,14 +2215,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf' )
 !--                 surface temperature for surfaces
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_surf_av(m) =                               & 
-                                          surf_usm_h%t_surf_av(m) /            &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_surf_av(m) =                               &
+                                             surf_usm_h%t_surf_av(m) /            &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_surf_av(m) =                         &
@@ -2141,14 +2231,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf_window' )
 !--                 surface temperature for window surfaces
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_surf_window_av(m) =                               & 
-                                          surf_usm_h%t_surf_window_av(m) /            &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_surf_window_av(m) =                               &
+                                             surf_usm_h%t_surf_window_av(m) /            &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_surf_window_av(m) =                         &
@@ -2156,14 +2247,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf_green' )
 !--                 surface temperature for green surfaces
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_surf_green_av(m) =                               & 
-                                          surf_usm_h%t_surf_green_av(m) /            &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_surf_green_av(m) =                               &
+                                             surf_usm_h%t_surf_green_av(m) /            &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_surf_green_av(m) =                         &
@@ -2171,14 +2263,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf_10cm' )
 !--                 near surface temperature for whole surfaces
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_surf_10cm_av(m) =                               & 
-                                          surf_usm_h%t_surf_10cm_av(m) /            &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_surf_10cm_av(m) =                               &
+                                             surf_usm_h%t_surf_10cm_av(m) /            &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_surf_10cm_av(m) =                         &
@@ -2186,14 +2279,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_wall' )
 !--                 wall temperature for  iwl layer of walls and land
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_wall_av(iwl,m) =                           &
-                                          surf_usm_h%t_wall_av(iwl,m) /        &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_wall_av(iwl,m) =                           &
+                                             surf_usm_h%t_wall_av(iwl,m) /        &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_wall_av(iwl,m) =                     &
@@ -2201,14 +2295,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_t_window' )
 !--                 window temperature for  iwl layer of walls and land
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_window_av(iwl,m) =                           &
-                                          surf_usm_h%t_window_av(iwl,m) /        &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_window_av(iwl,m) =                           &
+                                             surf_usm_h%t_window_av(iwl,m) /        &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_window_av(iwl,m) =                     &
@@ -2216,14 +2311,15 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_t_green' )
 !--                 green temperature for  iwl layer of walls and land
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_green_av(iwl,m) =                           &
-                                          surf_usm_h%t_green_av(iwl,m) /        &
-                                          REAL( average_count_3d, kind=wp )
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_green_av(iwl,m) =                           &
+                                             surf_usm_h%t_green_av(iwl,m) /        &
+                                             REAL( average_count_3d, kind=wp )
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_green_av(iwl,m) =                     &
@@ -2231,5 +2327,5 @@
                                           REAL( average_count_3d, kind=wp )
                        ENDDO
-                    ENDDO
+                    ENDIF
 
 
@@ -2309,12 +2405,17 @@
              var(1:9)  == 'usm_wshf_'  .OR.  var(1:9) == 'usm_wghf_' .OR.                 &
              var(1:16) == 'usm_wghf_window_' .OR. var(1:15) == 'usm_wghf_green_' .OR.     &
-             var(1:10) == 'usm_iwghf_' .OR. var(1:17) == 'usm_iwghf_window_' )  THEN
+             var(1:10) == 'usm_iwghf_' .OR. var(1:17) == 'usm_iwghf_window_' .OR.         &
+             var(1:17) == 'usm_surfwintrans_' )  THEN
             unit = 'W/m2'
-        ELSE IF ( var(1:10) == 'usm_t_surf'   .OR.  var(1:10) == 'usm_t_wall' .OR.         &
+        ELSE IF ( var(1:10) == 'usm_t_surf'   .OR.  var(1:10) == 'usm_t_wall' .OR.        &
                   var(1:12) == 'usm_t_window' .OR. var(1:17) == 'usm_t_surf_window' .OR.  &
                   var(1:16) == 'usm_t_surf_green'  .OR.                                   &
                   var(1:11) == 'usm_t_green' .OR.                                         &
-                  var(1:15) == 'usm_t_surf_10cm')  THEN
+                  var(1:15) == 'usm_t_surf_10cm' )  THEN
             unit = 'K'
+        ELSE IF ( var == 'usm_rad_pc_inlw'  .OR.  var == 'usm_rad_pc_insw'  .OR.          &
+                  var == 'usm_rad_pc_inswdir'  .OR.  var == 'usm_rad_pc_inswdif'  .OR.    &
+                  var == 'usm_rad_pc_inswref' )  THEN
+            unit = 'W'
         ELSE IF ( var(1:9) == 'usm_surfz'  .OR.  var(1:7) == 'usm_svf'  .OR.              & 
                   var(1:7) == 'usm_dif'  .OR.  var(1:11) == 'usm_surfcat'  .OR.           &
@@ -2417,5 +2518,5 @@
         INTEGER(iwp), DIMENSION(0:nd-1)                        :: dirstart
         INTEGER(iwp), DIMENSION(0:nd-1)                        :: dirend
-        INTEGER(iwp)                                           :: ids,idsint,idsidx,isurf,isvf,isurfs,isurflt
+        INTEGER(iwp)                                           :: ids,idsint,idsidx,isurf,isvf,isurfs,isurflt,ipcgb
         INTEGER(iwp)                                           :: is,js,ks,i,j,k,iwl,istat, l, m
 
@@ -2431,5 +2532,5 @@
             k = len(TRIM(var))
             j = len(TRIM(dirname(i)))
-            IF ( var(k-j+1:k) == dirname(i) )  THEN
+            IF ( TRIM(var(k-j+1:k)) == TRIM(dirname(i)) )  THEN
                 ids = i
                 idsint = dirint(ids)
@@ -2802,4 +2903,56 @@
                    ENDIF
                  ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_pc_inlw' )
+!--           array of lw radiation absorbed by plant canopy
+              DO ipcgb = 1, npcbl
+                  IF ( av == 0 )  THEN
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinlw(ipcgb)
+                  ELSE
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinlw_av(ipcgb)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_pc_insw' )
+!--           array of sw radiation absorbed by plant canopy
+              DO ipcgb = 1, npcbl
+                  IF ( av == 0 )  THEN
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinsw(ipcgb)
+                  ELSE
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinsw_av(ipcgb)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_pc_inswdir' )
+!--           array of direct sw radiation absorbed by plant canopy
+              DO ipcgb = 1, npcbl
+                  IF ( av == 0 )  THEN
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinswdir(ipcgb)
+                  ELSE
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinswdir_av(ipcgb)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_pc_inswdif' )
+!--           array of diffuse sw radiation absorbed by plant canopy
+              DO ipcgb = 1, npcbl
+                  IF ( av == 0 )  THEN
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinswdif(ipcgb)
+                  ELSE
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinswdif_av(ipcgb)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_pc_inswref' )
+!--           array of reflected sw radiation absorbed by plant canopy
+              DO ipcgb = 1, npcbl
+                  IF ( av == 0 )  THEN
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinsw(ipcgb)      &
+                                                                              - pcbinswdir(ipcgb) &
+                                                                              - pcbinswdif(ipcgb)
+                  ELSE
+                      temp_pf(pcbl(iz,ipcgb),pcbl(iy,ipcgb),pcbl(ix,ipcgb)) = pcbinswref_av(ipcgb)
+                  ENDIF
               ENDDO
  
@@ -3356,5 +3509,5 @@
           CASE DEFAULT
               found = .FALSE.
-              
+              RETURN
         END SELECT
 
@@ -3399,5 +3552,7 @@
              var(1:14) == 'usm_rad_outsw_'  .OR.  var(1:14) == 'usm_rad_outlw_'  .OR.       &
              var(1:14) == 'usm_rad_ressw_'  .OR.  var(1:14) == 'usm_rad_reslw_'  .OR.       &
-             var(1:11) == 'usm_rad_hf_'  .OR.                                               &
+             var(1:11) == 'usm_rad_hf_'  .OR.  var == 'usm_rad_pc_inlw'  .OR.               &
+             var == 'usm_rad_pc_insw'  .OR.  var == 'usm_rad_pc_inswdir'  .OR.              &
+             var == 'usm_rad_pc_inswdif'  .OR.  var == 'usm_rad_pc_inswref'  .OR.           &
              var(1:9) == 'usm_wshf_'  .OR.  var(1:9) == 'usm_wghf_'  .OR.                   &
              var(1:16) == 'usm_wghf_window_'  .OR. var(1:15) == 'usm_wghf_green_' .OR.      &
@@ -4965,5 +5120,5 @@
                                  * wintend(nzb_wall:nzt_wall) + tsc(3)            &
                                  * surf_usm_h%tt_window_m(nzb_wall:nzt_wall,m) )   
-           
+
 !
 !--        calculate t_wall tendencies for the next Runge-Kutta step
@@ -5168,4 +5323,10 @@
               ENDIF
            ENDDO
+!!!!!!!!!!!!!HACK!!!!!!!!!!!!!!!!!!!
+!           t_window_v_p(l)%t = t_wall_v_p(l)%t
+!           surf_usm_v(l)%tt_window_m  = surf_usm_v(l)%tt_wall_m
+!           t_green_v_p(l)%t = t_wall_v_p(l)%t
+!           surf_usm_v(l)%tt_green_m  = surf_usm_v(l)%tt_wall_m
+!!!!!!!!!!!!!HACK!!!!!!!!!!!!!!!!!!!
         ENDDO
 
